﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Sdl.FileTypeSupport.Framework.BilingualApi;
using Sdl.FileTypeSupport.Framework.NativeApi;
using System.Xml.Linq;
using Xliff20FileType.Common;

namespace Xliff20FileType.Parser
{
    abstract class AbstractBcmGenerator
    {
        public BcmGeneratorRepository Repository
        {
            get;
            set;
        }

        public abstract NodeSpec SupportedNode
        {
            get;
        }

        public IDocumentItemFactory ItemFactory
        {
            get
            {
                return Repository.ItemFactory;
            }
        }

        public IPropertiesFactory PropertiesFactory
        {
            get
            {
                return Repository.PropertiesFactory;
            }            
        }

        public abstract void GenerateContent(UnitInfo context, XNode node, IAbstractMarkupDataContainer targetContainer);
    }
}
