﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Sdl.FileTypeSupport.Framework.BilingualApi;
using System.Xml.Linq;
using Sdl.FileTypeSupport.Framework.NativeApi;
using Xliff20FileType.Common;

namespace Xliff20FileType.Parser
{
    class PhGenerator : AbstractBcmGenerator
    {
        public override NodeSpec SupportedNode
        {
            get { return new NodeSpec {  NodeType = System.Xml.XmlNodeType.Element, ElementName = XName.Get("ph", XliffConstants.Xliff20CoreNamespace) }; }
        }

        public override void GenerateContent(UnitInfo unitInfo, XNode node, IAbstractMarkupDataContainer targetContainer)
        {
            XElement phElement = (XElement)node;

            string dataRef = phElement.Attribute("dataRef").Value;
            OriginalData data = unitInfo.GetOriginalData(dataRef);

            // basic properties
            IPlaceholderTagProperties properties = PropertiesFactory.CreatePlaceholderTagProperties(data.Contents);
            properties.TagId = new TagId(phElement.Attribute("id").Value);
            properties.DisplayText = (string)phElement.Attribute("disp") ?? data.Contents;
            
            // validation
            XAttribute canDeleteAttribute = phElement.Attribute("canDelete");
            if (canDeleteAttribute != null)
            {
                properties.SetMetaData("canDelete", canDeleteAttribute.Value);
            }

            // create tag and add to container
            IPlaceholderTag tag = ItemFactory.CreatePlaceholderTag(properties);
            targetContainer.Add(tag);
        }
    }
}
