﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using Sdl.FileTypeSupport.Framework.BilingualApi;
using Xliff20FileType.Common;
using Sdl.FileTypeSupport.Framework.NativeApi;

namespace Xliff20FileType.Parser
{
    class TextGenerator : AbstractBcmGenerator
    {
        public override NodeSpec SupportedNode
        {
            get { return new NodeSpec { NodeType = System.Xml.XmlNodeType.Text }; }
        }

        public override void GenerateContent(UnitInfo unitInfo, XNode node, IAbstractMarkupDataContainer targetContainer)
        {
            XText textElement = (XText)node;
            ITextProperties textProperties = PropertiesFactory.CreateTextProperties(textElement.Value);
            targetContainer.Add(Repository.ItemFactory.CreateText(textProperties));
        }
    }
}
