﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Sdl.FileTypeSupport.Framework.Formatting;
using System.Drawing;

namespace Xliff20FileType.Parser
{
    class XliffFormatting
    {

        public static IFormattingGroup CreateFormatting(IFormattingItemFactory factory, string fsValue)
        {
            IFormattingGroup group = factory.CreateFormatting();
            switch (fsValue)
            {
                case "a":
                    group.Add(new Underline());
                    group.Add(new TextColor(Color.Blue));
                    break;
                case "b":
                    group.Add(new Bold());
                    break;
                case "i":
                    group.Add(new Italic());
                    break;
                case "h1":
                    group.Add(new Sdl.FileTypeSupport.Framework.Formatting.FontSize(24));
                    group.Add(new Bold());
                    break;
                case "h2":
                    group.Add(new Sdl.FileTypeSupport.Framework.Formatting.FontSize(18));
                    group.Add(new Bold());
                    break;
                case "h3":
                    group.Add(new Sdl.FileTypeSupport.Framework.Formatting.FontSize(16));
                    group.Add(new Bold());
                    break;
                default:
                    return null;
            }
            return group;
        }
    }
}
